var pre_index = 0;
var cur_index = 0;
var resource_length = 3;
var timeout = 50;
var cur_time = 0;

var LoadingLayer = cc.LayerColor.extend({
    _progress:null,
    _cb:null,
    ctor:function (length, cb) {
        //////////////////////////////
        // 1. super init first
        this._super(cc.color(255,255,255));
        this._cb = cb;
        
       // this.createComponents();
        
        this.initProgress(length);
        
        this.loadResource();
        
        this.scheduleUpdate();
        
        return true;
    },
    createComponents:function(){
    	var background = new cc.Sprite("res/game_select/background.jpg");
    	background.x = cc.winSize.width / 2;
    	background.y = cc.winSize.height / 2;
    	resetScale(background);
    	this.addChild(background);
    },
    initProgress:function(length){
    	cur_index = 0;
    	resource_length = length;
    },
    loadingCB:function(){
    	if (cur_index >= this.length) {
			var self = this;
			if(self._cb){
				self._cb();
			}
		}
    },
    loadResource:function(){
    	var self = this;

    	for (var index = 0; index < resource_length; ++index) {
    		cc.textureCache.addImageAsync(texturePath(1 + cur_index, ".pvr.ccz"), function() {
    			cc.spriteFrameCache.addSpriteFrames(texturePath(1 + cur_index, ".plist"));
    			cur_index++;
    			if (cur_index >= resource_length) {
    				var self = this;
    				if(self._cb){
    					self._cb();
    				}
    			}
			});
    	}
    },
    update:function(){
    	this.checkCurTime();
    },
    checkCurTime:function(){
    	if (pre_index != cur_index) {
			pre_index = cur_index;
			cur_time = 0;
		}else {
			cur_time++;
			if (cur_time >= timeout) {
				this.unscheduleUpdate();
				if (this._cb) {
					this._cb();
				}
			}
		}
    }
});

var LoadingScene = cc.Scene.extend({
	ctor:function(length, cb){
		this._super();
		var layer = new LoadingLayer(length, cb);
		this.addChild(layer);
	},
    onEnter:function () {
        this._super();
    }
});

